%==========================================================================
%                       Lectura de datos
%==========================================================================
c_w1=cluster(1,1);
c_w2=cluster(1,2);
alfa_w=cluster(1,3);
alfa_theta=cluster(1,4);
rho_w=cluster(1,5);
rho_theta=cluster(1,6);
lambda_w1=cluster(1,7);
lambda_w2=cluster(1,8);
w_max=cluster(1,9);
w_min=cluster(1,10);
theta_max=cluster(1,11);
theta_min=cluster(1,12);
w1_max=cluster(1,13);
w1_min=cluster(1,14);
delta_w12_max=cluster(1,15);
delta_w12_min=cluster(1,16);
w2_max=w1_max;
w2_min=w1_min;
w12_max=w1_max;
w12_min=w1_min;
%==========================================================================
%                         acondicionamiento de datos
%==========================================================================
n_w=max([length(S_w_w1) length(S_w_w2)]);
n_theta=max([length(S_theta_w1) length(S_theta_w2)]);
S_w_w1(end:n_w,1)=S_w_w1(end);
S_w_w2(end:n_w,1)=S_w_w2(end);
S_theta_w1(end:n_theta,1)=S_theta_w1(end);
S_theta_w2(end:n_theta,1)=S_theta_w2(end);
S_w=[S_w_w1 S_w_w2];
S_theta=[S_theta_w1 S_theta_w2];
Stotal=[S_w; S_theta];
p_w=n_w+c_w1+c_w2;
p_theta=n_theta+c_w1+c_w2;
%==========================================================================
%                       Clculo de la matriz G
%==========================================================================
c=[c_w1 c_w2];
G=zeros(1,sum(c));
for i=1:2
    switch i;
        case 1
            p=p_w;
            n=n_w;
            S=S_w;
        case 2
            p=p_theta;
            n=n_theta;
            S=S_theta;            
    end
    Saux=[S; ones(p-n,2)*[S(end,1) 0; 0 S(end,2)]];
    Gaux=zeros(p,sum(c));
    k=0;
    for j=1:2
        for i=1:c(j);
            Gaux(i:end,k+i)=Saux(1:p-i+1,j);
        end
        k=sum(c(1:j));
    end
    G=[G;Gaux];
end
G=G(2:end,:);
%==========================================================================
%                Clculo de las matrices alfa y lambda
%==========================================================================
alfa=alfa_w*eye(p_w,p_w);
alfa(end+1:end+p_theta,end+1:end+p_theta)=alfa_theta*eye(p_theta,p_theta);
lambda=lambda_w1*eye(c_w1,c_w1);
lambda(end+1:end+c_w2,end+1:end+c_w2)=lambda_w2*eye(c_w2,c_w2);
%==========================================================================
%               Clculo de las matrices M. estrella y T
%==========================================================================
M_w_est=zeros(n_w,n_w);
M_w_est(1:end-1,2:end)=eye(n_w-1,n_w-1);
M_w_est(end,end)=1;
M_theta_est=zeros(n_theta,n_theta);
M_theta_est(1:end-1,2:end)=eye(n_theta-1,n_theta-1);
M_theta_est(end,end)=1;
M_est=M_w_est;
M_est(end+1:end+n_theta,end+1:end+n_theta)=M_theta_est;
T=0;
for i=1:2;
    switch i
        case 1
            p=p_w;
            n=n_w;
            M=M_w_est;
        case 2
            p=p_theta;
            n=n_theta;
            M=M_theta_est;
    end
    Taux=zeros(p,n);
    Taux(1:n-1,2:end)=eye(n-1,n-1);
    Taux(n:end,end)=1.0;
    T(end+1:end+p,end+1:end+n)=Taux;
end
T=T(2:end,2:end);
%==========================================================================
%                       Matrices para el algoritmo QP             
%==========================================================================
Q=[[G'*alfa*G+lambda,zeros(c_w1+c_w2,2)];[zeros(2,c_w1+c_w2),[rho_w 0;0 rho_theta]]];
mC1=-G'*alfa;
D1=zeros(c_w1+c_w2,c_w1+c_w2);
for j=1:2
    if j==1;
        a=1;
        b=c_w1;
    elseif j==2
        a=c_w1+1;
        b=c_w1+c_w2;
    end
    for k=a:b;
        D1(k,a:k)=1;
    end
end
D1=[D1, zeros(size(D1,1),2)];
a=zeros(p_w+p_theta,2);
a(1:p_w,1)=-1;
a(p_w+1:p_w+p_theta,2)=-1;
D2=[[G; G],[a;-a]];
b=[zeros(2,c_w1+c_w2),[-1 0;0 -1]];
D=[D1;D2;b;-b];
Urestmax=[w1_max*ones(c_w1,1); w2_max*ones(c_w2,1)];
Urestmin=[w1_min*ones(c_w1,1); w2_min*ones(c_w2,1)];
Yrestmax=[w_max*ones(p_w,1); theta_max*ones(p_theta,1);...
    inf*ones(p_w+p_theta,1);0;0;inf;inf];
Yrestmin=[-inf*ones(p_w+p_theta,1); w_min*ones(p_w,1); theta_min*ones(p_theta,1);...
    -inf;-inf;0;0];
restmax=[Urestmax; Yrestmax];
restmin=[Urestmin; Yrestmin];
xmin=[delta_w12_min*ones(c_w1,1); delta_w12_min*ones(c_w2,1); 0; 0];
xmax=[delta_w12_max*ones(c_w1,1); delta_w12_max*ones(c_w2,1); inf; inf];
%==========================================================================
%                       matrices para el inicio           
%==========================================================================
libre0=[wmedida*ones(n_w,1);thetamedido*ones(n_theta,1)];%inicializacion de la resuesta libre
Gesp=[G(1,:);G(p_w+1,:)];


