vhdpw=[1 2 3 4 5 6 7 8 9 10 15 20 22];
vhdptheta=[1 2 3 4 5 6 7 8 9 10 15 20 22];
vhdcw1=[1  4 ];
vhdcw2=[1  3 ];
c_w1=vhdcw1(end);
c_w2=vhdcw2(end);
%==========================================================================
%                       Lectura de datos
%==========================================================================
alfa_w=cluster(1,1);
alfa_theta=cluster(1,2);
lambda_w1=cluster(1,3);
lambda_w2=cluster(1,4);
w_max=cluster(1,5);
w_min=cluster(1,6);
theta_max=cluster(1,7);
theta_min=cluster(1,8);
w1_max=cluster(1,9);
w1_min=cluster(1,10);
w2_max=cluster(1,11);
w2_min=cluster(1,12);
%==========================================================================
%                         acondicionamiento de datos
%==========================================================================
n_w=max([length(S_w_w1) length(S_w_w2)]);
n_theta=max([length(S_theta_w1) length(S_theta_w2)]);
S_w_w1(end:n_w,1)=S_w_w1(end);
S_w_w2(end:n_w,1)=S_w_w2(end);
S_theta_w1(end:n_theta,1)=S_theta_w1(end);
S_theta_w2(end:n_theta,1)=S_theta_w2(end);
S_w=[S_w_w1 S_w_w2];
S_theta=[S_theta_w1 S_theta_w2];
Stotal=[S_w; S_theta];
p_w=n_w+c_w1+c_w2;
p_theta=n_theta+c_w1+c_w2;
if vhdpw(end)<p_w;
    vhdpw(end+1)=p_w;
else
    p_w=vhdpw(end);
end
if vhdptheta(end)<p_theta;
    vhdptheta(end+1)=p_theta;
    else
    p_theta=vhdptheta(end);
end
%==========================================================================
%                       Clculo de la matriz G
%==========================================================================
c=[c_w1 c_w2];
G=zeros(1,sum(c));
for i=1:2
    switch i;
        case 1
            p=p_w;
            n=n_w;
            S=S_w;
        case 2
            p=p_theta;
            n=n_theta;
            S=S_theta;            
    end
    Saux=[S; ones(p-n,2)*[S(end,1) 0; 0 S(end,2)]];
    Gaux=zeros(p,sum(c));
    k=0;
    for j=1:2
        for i=1:c(j);
            Gaux(i:end,k+i)=Saux(1:p-i+1,j);
        end
        k=sum(c(1:j));
    end
    G=[G;Gaux];
end
G=G(2:end,:);
G1=zeros(length(vhdpw)+length(vhdptheta),c_w1+c_w2);
for i=1:length(vhdpw);
    G1(i,:)=G(vhdpw(i),:);
end
a=length(vhdpw);
for i=a+1:a+length(vhdptheta);
    G1(i,:)=G((vhdptheta(i-a))+p_w,:);
end
G2=zeros(length(vhdpw)+length(vhdptheta),length(vhdcw1)+length(vhdcw2));
for i=1:length(vhdcw1);
    G2(:,i)=G1(:,vhdcw1(i));
end
a=length(vhdcw1);
for i=a+1:a+length(vhdcw2);
    G2(:,i)=G1(:,vhdcw2(i-a)+c_w1);
end
G=G2;
%==========================================================================
%                Clculo de las matrices alfa y lambda
%==========================================================================
alfa=alfa_w*eye(length(vhdpw),length(vhdpw));
alfa(end+1:end+length(vhdptheta),end+1:end+length(vhdptheta))=alfa_theta*eye(length(vhdptheta),length(vhdptheta));
lambda=lambda_w1*eye(length(vhdcw1),length(vhdcw1));
lambda(end+1:end+length(vhdcw2),end+1:end+length(vhdcw2))=lambda_w2*eye(length(vhdcw2),length(vhdcw2));
%==========================================================================
%               Clculo de las matrices M. estrella y T
%==========================================================================
M_w_est=zeros(n_w,n_w);
M_w_est(1:end-1,2:end)=eye(n_w-1,n_w-1);
M_w_est(end,end)=1;
M_theta_est=zeros(n_theta,n_theta);
M_theta_est(1:end-1,2:end)=eye(n_theta-1,n_theta-1);
M_theta_est(end,end)=1;
M_est=M_w_est;
M_est(end+1:end+n_theta,end+1:end+n_theta)=M_theta_est;
T=0;
for i=1:2;
    switch i
        case 1
            p=p_w;
            n=n_w;
            M=M_w_est;
        case 2
            p=p_theta;
            n=n_theta;
            M=M_theta_est;
    end
    Taux=zeros(p,n);
    Taux(1:n-1,2:end)=eye(n-1,n-1);
    Taux(n:end,end)=1.0;
    T(end+1:end+p,end+1:end+n)=Taux;
end
T=T(2:end,2:end);
%==========================================================================
%                       Matrices para el algoritmo QP             
%==========================================================================
Q=G'*alfa*G+lambda;
%Q=((Q+Q'))/2;
p_w_0=p_w;
p_theta_0=p_theta;
c_w1_0=c_w1;
c_w2_0=c_w2;
p_w=length(vhdpw);
p_theta=length(vhdptheta);
c_w1=length(vhdcw1);
c_w2=length(vhdcw2);
D1=zeros(c_w1+c_w2,c_w1+c_w2);
for j=1:2
    if j==1;
        a=1;
        b=c_w1;
    elseif j==2
        a=c_w1+1;
        b=c_w1+c_w2;
    end
    for k=a:b;
        D1(k,a:k)=1;
    end
end
D2=G;
D=[D1;D2];
Urestmax=[w1_max*ones(c_w1,1); w2_max*ones(c_w2,1)];
Urestmin=[w1_min*ones(c_w1,1); w2_min*ones(c_w2,1)];
Yrestmax=[w_max*ones(p_w,1); theta_max*ones(p_theta,1)];
Yrestmin=[w_min*ones(p_w,1); theta_min*ones(p_theta,1)];
restmax=[Urestmax; Yrestmax];
restmin=[Urestmin; Yrestmin];
mC1=-G'*alfa;
xmin=[w1_min*ones(c_w1,1);w2_min*ones(c_w2,1)];
xmax=[w1_max*ones(c_w1,1);w2_max*ones(c_w2,1)];
hc_w1=c_w1;
hc_w2=c_w2;
hp_w=p_w;
hp_theta=p_theta;
p_w=p_w_0;
p_theta=p_theta_0;
c_w1=c_w1_0;
c_w2=c_w2_0;
%==========================================================================
%                       matrices para el inicio           
%==========================================================================
libre0=[wmedida*ones(n_w,1);thetamedido*ones(n_theta,1)];%inicializacion de la resuesta libre
vhdp=[vhdpw, p_w+vhdptheta];
mvhdp=zeros(length(vhdp),vhdp(end));
for i=1:length(vhdp);
    mvhdp(i,vhdp(i))=1;
end
Gesp=[G(1,:);G(length(vhdpw)+1,:)];



